package cn.net.connor.createTempDrawings.dialogs;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Label;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.swing.*;

import com.teamcenter.rac.aif.AbstractAIFApplication;
import com.teamcenter.rac.aif.AbstractAIFDialog;
import com.teamcenter.rac.aif.kernel.InterfaceAIFComponent;
import com.teamcenter.rac.kernel.TCComponentFolder;
import com.teamcenter.rac.kernel.TCComponentItemRevision;
import com.teamcenter.rac.kernel.TCException;
import com.teamcenter.rac.kernel.TCPreferenceService;
import com.teamcenter.rac.kernel.TCSession;
import com.teamcenter.rac.util.DateButton;
import com.teamcenter.rac.util.MessageBox;
import com.teamcenter.rac.util.PropertyLayout;
import com.teamcenter.rac.util.UIUtilities;

public class CreateTempDrawingDialog extends JFrame implements ActionListener{
	private AbstractAIFApplication application;
	private TCSession tcSession ;
	private InterfaceAIFComponent selectComponent;
	private JLabel drawingObjTypeLabel;//ͼֽͱǩ
	private JComboBox<String> drawingObjTypeComboBox;//ͼֽ
	private JButton okButton;//ȷϰť
	private JButton button1;//ť
	private JButton button2;//ť
	private List<String> drawingObjTypeInfos = new ArrayList<String>();//ѡõĶϢ
	private JFrame buildFram;
	private String currentChoosePropPreferenceName;//ǰѡ͵
	
	

	/**
	 * ๹캯
	 * @param application
	 * @param selectComponent
	 */
	public CreateTempDrawingDialog(AbstractAIFApplication application, InterfaceAIFComponent selectComponent) {
		try {
			this.application = application;
			this.tcSession = (TCSession) this.application.getSession();
			this.selectComponent = selectComponent;
			
			System.out.println("ʼشʱͼֽ壡");
			List<String> list1 = getPreferenceInfos("SB6_Create_LS_Design");
			if (list1.isEmpty() || list1.size() <= 0) {
				MessageBox.post("ȡѡSB6_Create_LS_DesignϢʧܣǷȷ" , "ʾ", MessageBox.INFORMATION);
				return;
			}else {
				if (this.drawingObjTypeInfos != null && this.drawingObjTypeInfos.size() > 0) {
					this.drawingObjTypeInfos.clear();
				}
				this.drawingObjTypeInfos.addAll(list1);
			}
			initUI();
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		
	}

	/**
	 * ѡƻȡѡϢ
	 * @param preferenceName ѡ
	 * @return List<String>
	 */
	public List<String> getPreferenceInfos(String preferenceName) {
		List<String> drawingObjPropInfosList = new ArrayList<>();

		TCPreferenceService preferenceService = tcSession.getPreferenceService();
		String[] values = preferenceService.getStringValues(preferenceName);
		if (values.length > 0) {
			for (int i = 0; i < values.length; i++) {
				drawingObjPropInfosList.add(values[i]);
			}
		}else {
			System.out.println("ȡѡ["+preferenceName+"]ϢʧܣǷȷ");
		}
		System.out.println("ȡѡ["+preferenceName+"]е["+values.length+"]Ϣ");
		return drawingObjPropInfosList;

	}

	/**
	 * ʱͼֽ-ѡ͵Ŀ
	 */
	private void initUI() throws Exception {
		this.setTitle("ѡͼֽ");
		this.setSize(800, 600);
        this.setLayout(new BorderLayout());

        JPanel centerPanel = new JPanel(new GridBagLayout());
		JPanel buttomPanel = new JPanel(new FlowLayout());
		
		this.drawingObjTypeLabel = new JLabel("ͼֽ		");
		//ȡͼֽ
		List<String> typList = getDrawingObjTypeShowName();
		if (typList.isEmpty() || typList.size() <= 0) {
			System.out.println("ȡͼֽʧܣѡǷȷ");
			return;
		}
		String[] drawingTypes = typList.toArray(new String[0]);
		this.drawingObjTypeComboBox = new JComboBox<String>(drawingTypes);
		drawingObjTypeComboBox.setPreferredSize(new Dimension(200, drawingObjTypeComboBox.getPreferredSize().height));
		drawingObjTypeComboBox.setEditable(false);

		GridBagConstraints gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.anchor = GridBagConstraints.WEST;
		gbc.insets = new Insets(0, 0, 0, 12); // ұ 10 صļ
		centerPanel.add(this.drawingObjTypeLabel, gbc);

		gbc.gridx = 1;
		centerPanel.add(drawingObjTypeComboBox, gbc);

		this.okButton = new JButton("ȷ");
		buttomPanel.add(okButton);
		

		//
		this.add(centerPanel, BorderLayout.CENTER);
		this.add(buttomPanel, BorderLayout.SOUTH);
		
		
		//ťʱ
		this.okButton.addActionListener(this);
		
		

		this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		this.setResizable(true);
  		this.setPreferredSize(new Dimension(800,600));
  		this.pack(); // ԶڴСӦڲ

		//ŵĻ
		UIUtilities.centerToScreen(this);
		
		this.setVisible(true);

	}

	/**
	 * ȡʱͼֽʱѡͽƼ
	 * @return List<String>
	 */
	private List<String> getDrawingObjTypeShowName() {
		List<String> drawingObjTypeList = new ArrayList<>();
		if (this.drawingObjTypeInfos != null && this.drawingObjTypeInfos.size() > 0){
			for (int i = 0; i < this.drawingObjTypeInfos.size(); i++) {
				String drawingObjTypeInfo = this.drawingObjTypeInfos.get(i);
				String[] drawingObjTypeInfoArray = drawingObjTypeInfo.split("=");
				if (drawingObjTypeInfoArray.length == 3) {//õϢֻ=
					drawingObjTypeList.add(drawingObjTypeInfoArray[0]);
				}else{
					System.out.println("Ϣ["+drawingObjTypeInfo+"]ʽȷѡǷȷ");
				}
			}
		}

		return drawingObjTypeList;
	}

	/**
	 * ȡѡеͼֽͶӦѡ
	 * @return
	 */
	private String getSelectTypePreferenceName() {
		String returnValue = null;
		//ǰѡеͼֽ
		String chooseType1 = (String) this.drawingObjTypeComboBox.getSelectedItem();

		List<String> drawingObjTypeList = new ArrayList<>();
		if (this.drawingObjTypeInfos != null && this.drawingObjTypeInfos.size() > 0){
			for (int i = 0; i < this.drawingObjTypeInfos.size(); i++) {
				String drawingObjTypeInfo = this.drawingObjTypeInfos.get(i);
				String[] drawingObjTypeInfoArray = drawingObjTypeInfo.split("=");
				if (drawingObjTypeInfoArray.length == 3) {//õϢֻ=
					//
					String typeName = drawingObjTypeInfoArray[0];
					if (chooseType1 != null && typeName != null){
						if (chooseType1.equals(typeName)) {
							returnValue = drawingObjTypeInfoArray[2];
							break;
						}
					}
				}else{
					System.out.println("Ϣ["+drawingObjTypeInfo+"]ʽȷѡǷȷ");
				}
			}
		}

		return returnValue;
	}
	
	

	@Override
	public void actionPerformed(ActionEvent e) {
		// TODO Զɵķ
		Object s = e.getSource();
		try {
			if (s.equals(this.okButton)) {
				String chooseType = (String) this.drawingObjTypeComboBox.getSelectedItem();
				System.out.println("ǰѡͼֽ="+chooseType);
				// رյǰ
				this.dispose();
				buildDrawingObjTypeFrame();
			}else if (s.equals(this.closeButton)) {
				System.out.println("رաť");
				// ر½
				this.buildFram.dispose();
			}else if (s.equals(this.buildButton)) {
				System.out.println("½ť");
				// ر½
				this.buildFram.dispose();




			}

			 
		} catch (Exception e2) {
			// TODO: handle exception
		}
			
		
	}

	
	
	private JLabel idLabel;
	private JTextField idTextField;
	private JLabel revLabel;
	private JComboBox<String> revComboBox;
	private List<String> showPropsInfoList = new ArrayList<>();
	private JButton closeButton;
	private JButton buildButton;
	/**
	 * ƶ͵ĴԻ
	 * @return
	 * @throws TCException 
	 */
	public JFrame buildDrawingObjTypeFrame() throws TCException{
		System.out.println("ͼֽ棡");
		// ½
		JFrame frame = new JFrame();
		frame.setTitle("ʱͼֽ");
		this.setSize(400, 300);
        this.setLayout(new BorderLayout());

        JPanel centerPanel1 = new JPanel(new GridBagLayout());
		JPanel buttomPanel1 = new JPanel(new FlowLayout());

		//1.Ŀ
		this.idLabel = new JLabel("ID*");
		String idValue = getIdValue(this.selectComponent);

		if (idValue != null){
			this.idTextField = new JTextField(idValue);
		}
		this.revLabel = new JLabel("汾");
		String[] revs = {"S01"};//汾
		this.revComboBox = new JComboBox<String>(revs);
//		this.revComboBox.setEditable(true);


//
		// ID Label
		GridBagConstraints gbcIdLabel = new GridBagConstraints();
		gbcIdLabel.gridx = 0;
		gbcIdLabel.gridy = 0;
		gbcIdLabel.anchor = GridBagConstraints.WEST;
		gbcIdLabel.insets = new Insets(5, 5, 5, 5);
		centerPanel1.add(this.idLabel, gbcIdLabel);

		// ID TextField
		GridBagConstraints gbcIdField = new GridBagConstraints();
		gbcIdField.gridx = 1;
		gbcIdField.gridy = 0;
		gbcIdField.anchor = GridBagConstraints.WEST;

		// Զ
		Dimension textFieldSize = new Dimension(200, idTextField.getPreferredSize().height); // 200ΪĿ
		idTextField.setPreferredSize(textFieldSize);

		centerPanel1.add(this.idTextField, gbcIdField);


		// 汾 Label
		GridBagConstraints gbcRevLabel = new GridBagConstraints();
		gbcRevLabel.gridx = 0;
		gbcRevLabel.gridy = 1;
		gbcRevLabel.anchor = GridBagConstraints.WEST;
		gbcRevLabel.insets = new Insets(5, 5, 5, 5);
		centerPanel1.add(this.revLabel, gbcRevLabel);

		// 汾 ComboBox
		GridBagConstraints gbcRevCombo = new GridBagConstraints();
		gbcRevCombo.gridx = 1;
		gbcRevCombo.gridy = 1;
		gbcRevCombo.anchor = GridBagConstraints.WEST;

		// Զ
		Dimension comboBoxSize = new Dimension(200, revComboBox.getPreferredSize().height); // 200ΪĿ
		revComboBox.setPreferredSize(comboBoxSize);

		centerPanel1.add(this.revComboBox, gbcRevCombo);
		String preferenceName = getSelectTypePreferenceName();
		int propIndex  = 2;
		if (preferenceName != null){
			List<String> propList = getPreferenceInfos(preferenceName);
			for(String propInfo : propList){//propInfoʽΪ*Ч=Form.sb6_validuntil=date=Form.sb6_validuntil
				String[] propConfigInfoArray= propInfo.split("=");
				if (propConfigInfoArray.length >= 3){
					String name = propConfigInfoArray[0];
					String type = propConfigInfoArray[2];

					// prop Label
					if (name != null && name.contains("*")){
						String chinese = extractChinese(name);
						name = chinese + "*";
					}
					JLabel propLabel = new JLabel(name);
					GridBagConstraints gbcPropLabel = new GridBagConstraints();
					gbcPropLabel.gridx = 0;
					gbcPropLabel.gridy = propIndex;
					gbcPropLabel.anchor = GridBagConstraints.WEST;
					gbcPropLabel.insets = new Insets(5, 5, 5, 5);
					centerPanel1.add(propLabel, gbcPropLabel);

					// prop value
					if (type != null){
						String typeValue = type.split(":")[0];
						if (typeValue.equals("string")){
							JTextField propTextField = new JTextField();

							GridBagConstraints gbcPropCombo = new GridBagConstraints();
							gbcPropCombo.gridx = 1;
							gbcPropCombo.gridy = propIndex;
							gbcPropCombo.anchor = GridBagConstraints.WEST;

							// Զ
							Dimension propValueSize = new Dimension(200, propTextField.getPreferredSize().height); // 200ΪĿ
							propTextField.setPreferredSize(propValueSize);

							centerPanel1.add(propTextField, gbcPropCombo);
						}else if (typeValue.equals("date")){
							DateButton dateButton = new DateButton(null, "yyyy-MM-dd", false, false, false);

							GridBagConstraints gbcPropCombo = new GridBagConstraints();
							gbcPropCombo.gridx = 1;
							gbcPropCombo.gridy = propIndex;
							gbcPropCombo.anchor = GridBagConstraints.WEST;

							// Զ
							Dimension propValueSize = new Dimension(200, dateButton.getPreferredSize().height); // 200ΪĿ
							dateButton.setPreferredSize(propValueSize);
							
							centerPanel1.add(dateButton, gbcPropCombo);
						} else if (typeValue.equals("lov")) {
							//TODO ðźLOVƻȡlovֵװӵpropComboBox
							//TODO ĵеļ̳ԴǸɶ
							String[] lovs = {"lov1","lov2","lov3"};//ģlovֵ
							JComboBox<String> propComboBox = new JComboBox<String>(lovs);
							//TODO ðźLOVƻȡlovֵװӵpropComboBox
							//TODO ĵеļ̳ԴǸɶ
							String[] lovs = {"lov1","lov2","lov3"};//ģlovֵ


							GridBagConstraints gbcPropCombo = new GridBagConstraints();
							gbcPropCombo.gridx = 1;
							gbcPropCombo.gridy = propIndex;
							gbcPropCombo.anchor = GridBagConstraints.WEST;

							// Զ
							Dimension propValueSize = new Dimension(200, propComboBox.getPreferredSize().height); // 200ΪĿ
							propComboBox.setPreferredSize(propValueSize);

							centerPanel1.add(propComboBox, gbcPropCombo);
							
						}
					}

					propIndex ++;
				}


			}

		}else {
			System.out.println("δҵѡͶӦѡѡSB6_Create_LS_DesignǷȷ");
		}

		
		
		
		
		
		//2.ť
		this.closeButton = new JButton("ر");
		buttomPanel1.add(closeButton);
		this.buildButton = new JButton("½");
		buttomPanel1.add(buildButton);

		//ť¼
		this.closeButton.addActionListener(this);
		this.buildButton.addActionListener(this);

		frame.add(centerPanel1, BorderLayout.CENTER);
		frame.add(buttomPanel1, BorderLayout.SOUTH);

		frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		frame.setResizable(true);
		frame.setPreferredSize(new Dimension(800,600));
		frame.pack(); // ԶڴСӦڲ

		//ŵĻ
		UIUtilities.centerToScreen(this);

		frame.setVisible(true);
		
		this.buildFram = frame;
		
		return frame;

	}

	/**
	 * ѡж(ҵ߼)ȡIDеĬֵ
	 * @param selectComponent2 ѡж
	 * @return IDеĬֵ
	 * @throws TCException 
	 */
	private String getIdValue(InterfaceAIFComponent selectComponent2) throws TCException {
//		String idValue = "";
		
		if(selectComponent2 instanceof TCComponentItemRevision){
			System.out.println("ǰѡжǰ汾󣬿ʼȡIDֵ");
			TCComponentItemRevision itemRevision = (TCComponentItemRevision) selectComponent2;
			String idValue = itemRevision.getStringProperty("item_id");
			if (idValue != null && !idValue.equals("")){
				return idValue.replace("_","");
			}else {{
				return null;//ȡ汾IDʧ
			}}
		}else if (selectComponent instanceof TCComponentFolder) {
			System.out.println("ǰѡжļж󣬴IDֵÿ");
			return "";
		}else {
			return  null;
		}
	}

	/**
	 * ֻȡַеַ
	 */
	public String extractChinese(String str) {
		if (str == null || str.isEmpty()) {
			return "";
		}
		// ʹʽƥַ
		Pattern pattern = Pattern.compile("[\\u4e00-\\u9fa5]+");
		Matcher matcher = pattern.matcher(str);

		StringBuilder sb = new StringBuilder();
		while (matcher.find()) {
			sb.append(matcher.group());
		}

		return sb.toString();
	}
	

}
